<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lab 5: Файл C:/VVID/Lab3/functions.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lab 5
   </div>
   <div id="projectbrief">Проект со строками</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Создано системой Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Поиск');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Поиск');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_9b007e028ff056209f37c38d42b1bdd5.html">VVID</a></li><li class="navelem"><a class="el" href="dir_d4d190ead145efec63d18fa6e1dbd727.html">Lab3</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Функции</a>  </div>
  <div class="headertitle">
<div class="title">Файл functions.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;functions.h&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Функции</h2></td></tr>
<tr class="memitem:a5de6fc215c07583f2346280c4505b953"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#a5de6fc215c07583f2346280c4505b953">isStrOk</a> (QString &amp;str)</td></tr>
<tr class="memdesc:a5de6fc215c07583f2346280c4505b953"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция проверки строки на то, чтобы в ней были только русские буквы и знаки припинания  <a href="#a5de6fc215c07583f2346280c4505b953">Подробнее...</a><br /></td></tr>
<tr class="separator:a5de6fc215c07583f2346280c4505b953"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc382b5636c4ef4323d4987e6064e251"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#afc382b5636c4ef4323d4987e6064e251">encryption</a> (QString &amp;str, int u)</td></tr>
<tr class="memdesc:afc382b5636c4ef4323d4987e6064e251"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция кодирования строки алгоритмом Цезаря со сдвигом u.  <a href="#afc382b5636c4ef4323d4987e6064e251">Подробнее...</a><br /></td></tr>
<tr class="separator:afc382b5636c4ef4323d4987e6064e251"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1a591b2c4dfddf027ec9211c5bca3361"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#a1a591b2c4dfddf027ec9211c5bca3361">isPalindrome</a> (QString &amp;str)</td></tr>
<tr class="memdesc:a1a591b2c4dfddf027ec9211c5bca3361"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция проверки строки на палиндром  <a href="#a1a591b2c4dfddf027ec9211c5bca3361">Подробнее...</a><br /></td></tr>
<tr class="separator:a1a591b2c4dfddf027ec9211c5bca3361"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f7a092751d1d5304734f66ce4bcaae8"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#a4f7a092751d1d5304734f66ce4bcaae8">amountOfVowels</a> (QString &amp;str)</td></tr>
<tr class="memdesc:a4f7a092751d1d5304734f66ce4bcaae8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция подсчёта гласных (включая ё)  <a href="#a4f7a092751d1d5304734f66ce4bcaae8">Подробнее...</a><br /></td></tr>
<tr class="separator:a4f7a092751d1d5304734f66ce4bcaae8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a338893bc1c71497f938ed3e104f8777b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#a338893bc1c71497f938ed3e104f8777b">amountOfConsonants</a> (QString &amp;str)</td></tr>
<tr class="memdesc:a338893bc1c71497f938ed3e104f8777b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция подсчёта согласных  <a href="#a338893bc1c71497f938ed3e104f8777b">Подробнее...</a><br /></td></tr>
<tr class="separator:a338893bc1c71497f938ed3e104f8777b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e3ba4f016256c26284c42c0821699d5"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#a0e3ba4f016256c26284c42c0821699d5">amountOfCharacter</a> (QString &amp;str)</td></tr>
<tr class="memdesc:a0e3ba4f016256c26284c42c0821699d5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция подсчёта букв(гласные согласные и "Ь,Ъ")  <a href="#a0e3ba4f016256c26284c42c0821699d5">Подробнее...</a><br /></td></tr>
<tr class="separator:a0e3ba4f016256c26284c42c0821699d5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af937e8937147e5ce0c31ffaa43468a9e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="functions_8cpp.html#af937e8937147e5ce0c31ffaa43468a9e">shorteringNumber</a> (QString &amp;str, int amountNumbers)</td></tr>
<tr class="memdesc:af937e8937147e5ce0c31ffaa43468a9e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Функция округления десятичного числа до заданного кол-ва знаков после запятой  <a href="#af937e8937147e5ce0c31ffaa43468a9e">Подробнее...</a><br /></td></tr>
<tr class="separator:af937e8937147e5ce0c31ffaa43468a9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Подробное описание</h2>
<div class="textblock"><dl class="section author"><dt>Автор</dt><dd>Sergei Baenkov </dd></dl>
<dl class="section version"><dt>Версия</dt><dd>1.0 </dd></dl>
</div><h2 class="groupheader">Функции</h2>
<a id="a0e3ba4f016256c26284c42c0821699d5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0e3ba4f016256c26284c42c0821699d5">&#9670;&nbsp;</a></span>amountOfCharacter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int amountOfCharacter </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция подсчёта букв(гласные согласные и "Ь,Ъ") </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока в которой нужно подсчитать кол-во согласных </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int :-1 - если строка пуста, int &gt; 0 если подсчитано успешно </dd></dl>
<div class="fragment"><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;{</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    {</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keywordflow">return</span> -1; <span class="comment">// Если строка пуста</span></div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    }</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    QString Chars = <span class="stringliteral">&quot;абвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ&quot;</span>;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    <span class="keywordtype">int</span> amount = 0;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    {</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        <span class="keywordflow">if</span> (Chars.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        {</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            amount++;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        }</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    }</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    <span class="keywordflow">return</span> amount;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a id="a338893bc1c71497f938ed3e104f8777b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a338893bc1c71497f938ed3e104f8777b">&#9670;&nbsp;</a></span>amountOfConsonants()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int amountOfConsonants </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция подсчёта согласных </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока в которой нужно подсчитать кол-во согласных </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int :-1 - если строка пуста, int &gt; 0 если подсчитано успешно </dd></dl>
<div class="fragment"><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;{</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keywordflow">return</span> -1; <span class="comment">// Если строка пуста</span></div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    }</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    QString Consonants = <span class="stringliteral">&quot;бвгджзйклмнпрстфхцчшщБВГДЖЗЙКЛМНПРСТФХЦЧШЩ&quot;</span>; <span class="comment">//Без ЬЪ</span></div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keywordtype">int</span> amount = 0;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;    {</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keywordflow">if</span> (Consonants.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        {</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            amount++;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        }</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    }</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    <span class="keywordflow">return</span> amount;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a id="a4f7a092751d1d5304734f66ce4bcaae8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4f7a092751d1d5304734f66ce4bcaae8">&#9670;&nbsp;</a></span>amountOfVowels()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int amountOfVowels </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция подсчёта гласных (включая ё) </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока в которой нужно подсчитать кол-во гласных </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int :-1 - если строка пуста, int &gt; 0 если подсчитано успешно </dd></dl>
<div class="fragment"><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;{</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    {</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        <span class="keywordflow">return</span> -1; <span class="comment">// Если строка пуста</span></div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    }</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    QString Vowels = <span class="stringliteral">&quot;аеёиоуыэюяАЕЁИОУЫЭЮЯ&quot;</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keywordtype">int</span> amount = 0;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    {</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <span class="keywordflow">if</span> (Vowels.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        {</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            amount++;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        }</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    }</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordflow">return</span> amount;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a id="afc382b5636c4ef4323d4987e6064e251"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afc382b5636c4ef4323d4987e6064e251">&#9670;&nbsp;</a></span>encryption()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int encryption </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>u</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция кодирования строки алгоритмом Цезаря со сдвигом u. </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока которую надо закодировать </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">u</td><td>Число сдвига </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int: 0 - если строка пуста -1 - если в строке находятся недопустимые символы -2 - если число сдвига меньше 1 1 - при успешном завершении кодирования </dd></dl>
<div class="fragment"><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;{</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    {</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;       <span class="keywordflow">return</span> 0; <span class="comment">// Если строка пуста, возвращает 0</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    }</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordflow">if</span> (u&lt;1)</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    {</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keywordflow">return</span> -2; <span class="comment">// Если число сдвига меньше 1 возвращает -2</span></div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    }</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="functions_8cpp.html#a5de6fc215c07583f2346280c4505b953">isStrOk</a>(str))</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    {</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordflow">return</span> -1; <span class="comment">// Если в строке находятся недопустимые символы, возвращает -1</span></div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    }</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    QString smallChars = <span class="stringliteral">&quot;абвгдеёжзийклмнопрстуфхцчшщъыьэюя&quot;</span>;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    QString bigChars = <span class="stringliteral">&quot;АБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ&quot;</span>;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keywordtype">int</span> size = str.size();</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;size ;i++)</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    {</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keywordflow">if</span> (smallChars.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        {</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keywordtype">int</span> newIndex = (smallChars.indexOf(str.at(i)) + u ) % 32;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;            str[i] = smallChars[newIndex];</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        }</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        <span class="keywordflow">else</span> <span class="keywordflow">if</span> (bigChars.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        {</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            <span class="keywordtype">int</span> newIndex = (bigChars.indexOf(str.at(i)) + u ) % 32;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;            str[i] = bigChars[newIndex];</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        }</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    }</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <span class="keywordflow">return</span> 1; <span class="comment">// При успешном завершении работы возвращает 1</span></div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;}</div><div class="ttc" id="functions_8cpp_html_a5de6fc215c07583f2346280c4505b953"><div class="ttname"><a href="functions_8cpp.html#a5de6fc215c07583f2346280c4505b953">isStrOk</a></div><div class="ttdeci">bool isStrOk(QString &amp;str)</div><div class="ttdoc">Функция проверки строки на то, чтобы в ней были только русские буквы и знаки припинания</div><div class="ttdef"><b>Definition:</b> functions.cpp:14</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a1a591b2c4dfddf027ec9211c5bca3361"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1a591b2c4dfddf027ec9211c5bca3361">&#9670;&nbsp;</a></span>isPalindrome()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int isPalindrome </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция проверки строки на палиндром </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока которую надо проверить </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int :-2 - если строка пуста -1 - если есть недопустимые символы 0 - если не палиндром 1 - если палиндром </dd></dl>
<div class="fragment"><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;{</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    {</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordflow">return</span> -2; <span class="comment">// Если строка пуста</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    }</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;\n&#39;</span>));</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keywordflow">if</span> (!<a class="code" href="functions_8cpp.html#a5de6fc215c07583f2346280c4505b953">isStrOk</a>(str))</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        <span class="keywordflow">return</span> -1; <span class="comment">// Если в строке есть недопустимые символы</span></div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    }</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    str.remove(QChar(<span class="charliteral">&#39; &#39;</span>));</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;.&#39;</span>));</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;!&#39;</span>));</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;?&#39;</span>));</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;,&#39;</span>));</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    str.remove(QChar(<span class="charliteral">&#39;-&#39;</span>));</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    {</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keywordflow">if</span> (!str.at(i).isLower())</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        {</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;            str[i] = str.at(i).toLower();</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        }</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    }</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    QString::iterator begin = str.begin();</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    QString::iterator end = str.end()-1;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    {</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        <span class="keywordflow">if</span> (*begin != *end)</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        {</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            <span class="keywordflow">return</span> 0; <span class="comment">// Это не палиндром</span></div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        }</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;        begin++;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        end--;</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    }</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordflow">return</span> 1; <span class="comment">// Это палиндром</span></div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;}</div><div class="ttc" id="functions_8cpp_html_a5de6fc215c07583f2346280c4505b953"><div class="ttname"><a href="functions_8cpp.html#a5de6fc215c07583f2346280c4505b953">isStrOk</a></div><div class="ttdeci">bool isStrOk(QString &amp;str)</div><div class="ttdoc">Функция проверки строки на то, чтобы в ней были только русские буквы и знаки припинания</div><div class="ttdef"><b>Definition:</b> functions.cpp:14</div></div>
</div><!-- fragment -->
</div>
</div>
<a id="a5de6fc215c07583f2346280c4505b953"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5de6fc215c07583f2346280c4505b953">&#9670;&nbsp;</a></span>isStrOk()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool isStrOk </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция проверки строки на то, чтобы в ней были только русские буквы и знаки припинания </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Cтрока которую надо проверить </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает true - если строка удовлетворяет условиям </dd></dl>
<div class="fragment"><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    QString allChars = <span class="stringliteral">&quot;абвгдеёжзийклмнопрстуфхцчшщъыьэюяАБВГДЕЁЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯ .!?,-&quot;</span>;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    {</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keywordflow">if</span> (allChars.indexOf(str.at(i)) == -1)</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        {</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        }</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    }</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="comment">//Провека на то есть ли буквы в этой строке</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    allChars.remove(allChars.indexOf(<span class="charliteral">&#39; &#39;</span>),6);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">int</span> amountLetter = 0;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    {</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keywordflow">if</span> (allChars.indexOf(str.at(i)) != -1)</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        {</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            amountLetter++;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        }</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    }</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordflow">if</span> (amountLetter == 0)</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    {</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">false</span>;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    }</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">true</span>;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
<a id="af937e8937147e5ce0c31ffaa43468a9e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af937e8937147e5ce0c31ffaa43468a9e">&#9670;&nbsp;</a></span>shorteringNumber()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int shorteringNumber </td>
          <td>(</td>
          <td class="paramtype">QString &amp;&#160;</td>
          <td class="paramname"><em>str</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>amountNumbers</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Функция округления десятичного числа до заданного кол-ва знаков после запятой </p>
<dl class="params"><dt>Аргументы</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">str</td><td>Исходное число в строке QString </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">amountNumbers</td><td>- кол-во знаков после запятой после округления </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Возвращает</dt><dd>Возвращает значение int :0 - если строка пуста -1 - если в строке есть недопустимые символы -2 - если колличество знаков после запятой неверное -3 - если в начале стоит не + или - -4 - если в строке больше знаков чем нужно -5 - если больше одной или не одной точки 1 - успешное округление </dd></dl>
<div class="fragment"><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;{</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordflow">if</span> (str.isEmpty())</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    {</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        <span class="keywordflow">return</span> 0; <span class="comment">// Если строка пуста</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    }</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <span class="keywordflow">if</span> ((str.size() - str.indexOf(<span class="charliteral">&#39;.&#39;</span>) - 1) &lt; amountNumbers || amountNumbers &lt; 1)</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    {</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <span class="keywordflow">return</span> -2; <span class="comment">// Если колличество знаков после запятой неверное</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    }</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    QString allChars = <span class="stringliteral">&quot;1234567890.-+&quot;</span>;</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    QString sign = <span class="stringliteral">&quot;+-&quot;</span>;</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <span class="keywordtype">int</span> amountDots = 0;</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <span class="keywordtype">int</span> amountSign = 0;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0;i&lt;str.size() ;i++)</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    {</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="keywordflow">if</span> (allChars.indexOf(str.at(i)) == -1 )</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        {</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;            i = str.size();</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;            <span class="keywordflow">return</span> -1; <span class="comment">//Если в строке есть недопустимые символы</span></div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        }</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="keywordflow">if</span> (str.at(i) == <span class="charliteral">&#39;+&#39;</span> || str.at(i) == <span class="charliteral">&#39;-&#39;</span>)</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        {</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            amountSign++;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        }</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="keywordflow">if</span> (str.at(i) == <span class="charliteral">&#39;.&#39;</span>)</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        {</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;            amountDots++;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        }</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    }</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordflow">if</span> (amountSign &gt; 1)</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    {</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        <span class="keywordflow">return</span> -4; <span class="comment">// Если в строке больше знаков чем нужно</span></div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    }</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    <span class="keywordflow">if</span> (amountSign == 1 )</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    {</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        amountNumbers--;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;        <span class="keywordflow">if</span> (sign.indexOf(str.at(0)) == -1)</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;        {</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            <span class="keywordflow">return</span> -3;</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        }</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    }</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keywordflow">if</span> (amountDots != 1)</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    {</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        <span class="keywordflow">return</span> -5;  <span class="comment">// Если в строке больше одной или не одной точки</span></div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    }</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    QString tmp = QString::number(str.toDouble(),<span class="charliteral">&#39;g&#39;</span>,str.size()-1);</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <span class="keywordflow">if</span> (amountSign == 1)</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    {</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        <span class="keywordflow">if</span> (str.indexOf(tmp) == -1)</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        {</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            <span class="keywordflow">return</span> -6;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        }</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    }</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="keywordflow">else</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    {</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;        <span class="keywordflow">if</span> (str != tmp)</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        {</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;            <span class="keywordflow">return</span> -6;</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        }</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    }</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    str = QString::number(str.toDouble(),<span class="charliteral">&#39;g&#39;</span>,str.indexOf(<span class="charliteral">&#39;.&#39;</span>)+amountNumbers); <span class="comment">// &#39;g&#39; - выводимый формат, число после</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;                                                                              <span class="comment">// него кол-во значащих цифр в числе</span></div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <span class="keywordflow">return</span> 1; <span class="comment">// При уcпешном выполнении округления</span></div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;}</div></div><!-- fragment -->
</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Создано системой &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
